/***** INCLUDES *****/
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <ctype.h>
#include <math.h>
#include <C:\DATEN\UNIVER~1\PROGRA~1\file.c>    /* functionen file*/

/***** CONSTANTEN *****/
#define SYNTAX "\nGeoTrans <projekt> <koordinatendatei> <messdatendatei>\n"
#define RO (M_PI/200)
/***** STRUCTUREN *****/
struct punkt
	{
	long int nr;
	double x[2];
	int n;
	}p[1000];
struct beobachtung
	{
	long int sp, zp;
	double r, s, z;
	}b[1000];

int suchpunkt(long int nr, int e);
/***** MAIN *****/
int main(int argc, char *argv[])
	{
	int a, fn=0, beo=0, buf,
		 i, j;
	long int stpk;
	char sbuf[255], pname[13];
	FILE *in1, *in2, *out, *err;

	if(argc < 4)
		{
		printf(SYNTAX);
		exit (1);
		}
	if(!projname(argv[1]))
		{
		printf("\nfalscher Projektname\n");
		printf(SYNTAX);
		exit(1);
		}

	/***** DATEIEN FFNEN *****/
	in1 = fileopen(argv[2], "r");
	in2 = fileopen(argv[3], "r");
	strncpy(pname, argv[1], 8);
	out = fileopen(strcat(pname, ".in"), "w");
	strncpy(pname, argv[1], 8);
	err =  fileopen(strcat(pname, ".err"), "w");
	strncpy(pname, argv[1], 8);

	/***** DATEN EINLESEN *****/
	while (!feof(in1))
		{
		fgets(sbuf, 255, in1);
		sscanf(sbuf, "%li %lf %lf", &p[fn].nr,&p[fn].x[0],&p[fn].x[1]); fn++;
		}
	while (!feof(in2))
		{
		fgets(sbuf, 255, in2);
		if (isdigit(sbuf[0])) a=atoi(sbuf); else a=0;
		switch(a)
			{
			case 1: sscanf(sbuf, "%i %li", &buf, &stpk); break;
			case 2: sscanf(sbuf, "%i %li %lf %lf %lf", &buf,&b[beo].zp,&b[beo].s,&b[beo].r,&b[beo].z); b[beo].sp=stpk; beo++; break;
			case 3: sscanf(sbuf, "%i %li %lf %lf %lf", &buf,&b[beo].zp,&b[beo].s,&b[beo].r,&b[beo].z); b[beo].sp=stpk; beo++; break;
			}
		}
	/* alle Punkte als ungenutzt markieren */
	for(i=0; i<fn; i++)
		p[i].n=0;
	/* Vorhandensein von Koordinaten prfen */
	for(i=0; i<beo; i++)
		{
		j=suchpunkt(b[i].sp, fn);
		if(j) p[j].n=1;
		else  fprintf(err, "* keine Stpk-Koordinaten %li\n", b[i].sp);
		j=suchpunkt(b[i].zp, fn);
		if(j) p[j].n=1;
		else  fprintf(err, "* keine  Zpk-Koordinaten %li\n", b[i].zp);
		}

	/***** DATEN SCHREIBEN *****/
	/* Punkte */
	for(i=0; i<fn; i++)
		if(p[i].n) fprintf(out, "2 %8li %12.3lf %12.3lf\n", p[i].nr, p[i].x[0], p[i].x[1]);
	/* Richtungen */
	for(i=0; i<beo; i++)
		fprintf(out, "3 %8li %8li %8.4lf 0.002\n", b[i].sp, b[i].zp, b[i].r);
	/* Strecken */
	for(i=0; i<beo; i++)
		fprintf(out, "4 %8li %8li %8.3lf 0.02\n", b[i].sp, b[i].zp, b[i].s*sin(b[i].z*RO));
	return 0;
	}
int suchpunkt(long int nr, int e)
	{
	int i;
	for(i=0; i<e; i++)
		if (p[i].nr == nr) return i;
	return 0;
	}